using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Security.Cryptography.X509Certificates;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Server.Kestrel.Core;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.Hosting;
using Microsoft.Extensions.Logging;
using MQTTnet.AspNetCore;

namespace MQTT_Broker
{
    public class Program
    {
        public static void Main(string[] args)
        {
            CreateHostBuilder(args).Build().Run();
        }

        public static IHostBuilder CreateHostBuilder(string[] args) =>
            Host.CreateDefaultBuilder(args)
                .ConfigureWebHostDefaults(webBuilder =>
                {
                    webBuilder.UseKestrel(o=> {
                        o.ListenAnyIP(1883, l => l.UseMqtt());
                        o.ListenAnyIP(9001, l => l.UseMqtt());
                        o.ListenAnyIP(9002, l => l.UseMqtt());
                        o.ListenAnyIP(5000); // default http pipeline

                        o.ListenAnyIP(5001, listenOptions =>
                        {
                            //   listenOptions.UseHttps("habook.pfx", "habook");
                             listenOptions.UseHttps("cert.pfx", "Pa$$w0rd");
                        });
                    }).UseStartup<Startup>();
                });
    }
}
